Package: groovy.transform.builder

## [Java] Class SimpleStrategy

- groovy.transform.builder.SimpleStrategy

-     public class SimpleStrategy
      extends BuilderASTTransformationAbstractBuilderStrategy

  This strategy is used with the Builder AST transform to modify your Groovy objects so that the setter methods for properties return the original object, thus allowing chained usage of the setters.

  You use it as follows:

       import groovy.transform.builder.*

       @Builder(builderStrategy=SimpleStrategy)
       class Person {
           String firstName
           String lastName
           int age
       }
       def person = new Person().setFirstName("Robert").setLastName("Lewandowski").setAge(21)
       assert person.firstName == "Robert"
       assert person.lastName == "Lewandowski"
       assert person.age == 21

  The `prefix` annotation attribute can be used to create setters with a different naming convention, e.g. with the prefix set to the empty String, you would use your setters as follows:

       def p1 = new Person().firstName("Robert").lastName("Lewandowski").age(21)

  or using a prefix of 'with':

       def p2 = new Person().withFirstName("Robert").withLastName("Lewandowski").withAge(21)

  When using the default prefix of "set", Groovy's normal setters will be replaced by the chained versions. When using a custom prefix, Groovy's unchained setters will still be available for use in the normal unchained fashion.

  The 'useSetters' annotation attribute can be used for writable properties as per the `Builder` transform documentation. The other annotation attributes for the `@Builder` transform for configuring the building process aren't applicable for this strategy.

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `build(BuilderASTTransformation transform, AnnotatedNode annotatedNode, AnnotationNode anno)`
    `` | `protected List<FieldNode>` | `getFields(BuilderASTTransformation transform, AnnotationNode anno, ClassNode buildee)`

- - ### Method Detail

    - #### @Override
      public void build(BuilderASTTransformation transform, AnnotatedNode annotatedNode, AnnotationNode anno)

    - #### @Override
      protected List<FieldNode> getFields(BuilderASTTransformation transform, AnnotationNode anno, ClassNode buildee)